#include "gamestatus.hpp"

gamestatus::gamestatus(int num_turns) :
                 timeofday_(DAWN),turn_(1),numTurns_(num_turns)
{}

const std::string& gamestatus::timeofdayDescription(gamestatus::TIME t)
{
	static const std::string times[] = { "Dawn ", "Day  ", "Dusk  ", "Night" };
	return times[t];
}

gamestatus::TIME gamestatus::timeofday() const
{
	return timeofday_;
}

int gamestatus::turn() const
{
	return turn_;
}

int gamestatus::number_of_turns() const
{
	return numTurns_;
}

bool gamestatus::next_turn()
{
	timeofday_ = static_cast<TIME>(static_cast<int>(timeofday_)+1);
	if(timeofday_ == NUM_TIMES)
		timeofday_ = DAWN;
	++turn_;
	return turn_ <= numTurns_;
}

double gamestatus::combat_modifier(unit_type::ALIGNMENT alignment) const
{
	if(alignment == unit_type::LAWFUL) {
		if(timeofday_ == DAY)
			return 1.25;
		else if(timeofday_ == NIGHT)
			return 0.75;
	} else if(alignment == unit_type::CHAOTIC) {
		if(timeofday_ == DAY)
			return 0.75;
		else if(timeofday_ == NIGHT)
			return 1.25;
	}

	return 1.0;
}
