#include "key.hpp"

#define KEY_TEST 0

#if (KEY_TEST == 1)

#include "video.hpp"

int main( void )
{
	SDL_Init(SDL_INIT_VIDEO);
	CVideo video( 640, 480, 16, 0 );
	CKey key;
	printf( "press enter (escape exits)...\n" );
	for(;;) {
		if( key[KEY_RETURN] != 0 )
			printf( "key(ENTER) pressed\n" );
		if( key[KEY_ESCAPE] != 0 )
			return 1;
	}
}

#endif

CKey::CKey() : is_enabled(true)
{
	static int num_keys = 300;
	key_list = SDL_GetKeyState( &num_keys );
}

CKey::~CKey()
{
}

int CKey::operator[]( int code )
{
	SDL_PumpEvents();
	return (code == KEY_ESCAPE || is_enabled) && int(key_list[code]);
}

void CKey::SetEnabled( bool enable )
{
	is_enabled = enable;
}
