#ifndef UNIT_H_INCLUDED
#define UNIT_H_INCLUDED

#include "config.hpp"
#include "map.hpp"
#include "unit_types.hpp"

#include <string>

class unit
{
public:
	unit(game_data& data, config& cfg);
	unit(const unit_type* t, int side);
	const unit_type& type() const;
	const std::string& description() const;
	int hitpoints() const;
	int experience() const;
	int side() const;
	bool can_recruit() const;
	int movement_left() const;
	bool can_attack() const;
	void set_movement(int moves);
	void set_attacked();
	void new_turn();

	bool gets_hit(int damage);

	void read(game_data& data, config& cfg);

	std::string write() const;

private:
	const unit_type* type_;
		
	int hitpoints_;
	int experience_;

	int side_;

	//is set to the number of moves left, and -1 if the unit has attacked
	int moves_;

	std::string description_;

	bool recruit_;
};

#endif
