#ifndef MENU_HPP_INCLUDED
#define MENU_HPP_INCLUDED

#include "display.hpp"
#include "SDL.h"
#include "video.hpp"

#include <string>
#include <vector>

namespace gui
{

enum DIALOG_TYPE { MESSAGE, OK_ONLY, YES_NO, OK_CANCEL };

//if a menu is given, then returns -1 if the dialog was cancelled, and the
//index of the selection otherwise. If no menu is given, returns the index
//of the button that was pressed
int show_dialog(display& screen, SDL_Surface* image,
                const std::string& caption, const std::string& message,
                DIALOG_TYPE type=MESSAGE,
                const std::vector<std::string>& menu_items=std::vector<std::string>()
			 );

}

#endif
