#ifndef TEAM_H_INCLUDED
#define TEAM_H_INCLUDED

#include "config.hpp"
#include "map.hpp"

#include <cassert>
#include <set>
#include <string>

class team
{
public:
	struct team_info
	{
		team_info(config& cfg);
		std::string name;
		std::set<std::string> can_recruit;
	};
		
	team(const team_info& info);
	void get_tower(const gamemap::location&);
	void lose_tower(const gamemap::location&);
	int towers() const;
	bool owns_tower(const gamemap::location&) const;

	int gold() const;
	void new_turn();
	void spend_gold(int amount);

	const std::set<std::string>& recruits() const;
	const std::string& name() const;
private:
	int gold_;
	std::set<gamemap::location> towers_;

	const team_info* info_;
};

#endif
